// Motor
/*
Sample Code to run the Sparkfun TB6612FNG 1A Dual Motor Driver using Arduino UNO R3

This code conducts a few simple manoeuvres to illustrate the functions:
 - motorDrive(motorNumber, motorDirection, motorSpeed)
 - motorBrake(motorNumber)
 - motorStop(motorNumber)
 - motorsStandby

// Connections:
//- Pin 3 ---> PWMA
//- Pin 8 ---> AIN2
//- Pin 11 ---> AIN1
//- Pin 7 ---> STBY
//- Pin 12 ---> BIN1
//- Pin 13 ---> BIN2
//- Pin 5 ---> PWMB

- Motor 1: A01 and A02
- Motor 2: B01 and B02

*/

//Define the Pins

//Motor 1
int pinAIN1 = 11; //Direction
int pinAIN2 = 8; //Direction
int pinPWMA = 3; //Speed

//Motor 2
int pinBIN1 = 12; //Direction
int pinBIN2 = 13; //Direction
int pinPWMB = 5; //Speed

//Standby
int pinSTBY = 7;

//Constants to help remember the parameters
static boolean turnCW = 0; //for motorDrive function
static boolean turnCCW = 1; //for motorDrive function
static boolean motor1 = 0; //for motorDrive, motorStop, motorBrake functions
static boolean motor2 = 1; //for motorDrive, motorStop, motorBrake functions

// Servo
#include <Servo.h>

Servo myservo1,myservo2,myservo3,myservo4;  // create servo object to control a servo

int a =1;
int b =1;
int c =1;
int d =1;

int val1;    // variable to read the value from the analog pin
int val2;    // variable to read the value from the analog pin
int val3;    // variable to read the value from the analog pin
int val4;    // variable to read the value from the analog pin

// HC-SR04
#define PIN_TRIG1 12
#define PIN_ECHO1 11

#define PIN_TRIG2 12
#define PIN_ECHO2 11

#define PIN_TRIG3 12
#define PIN_ECHO3 11

long duration1, cm1, duration2, cm2, duration3, cm3;

//

void setup() {
Serial.begin (9600);

pinMode(pinPWMA, OUTPUT);
pinMode(pinAIN1, OUTPUT);
pinMode(pinAIN2, OUTPUT);

pinMode(pinPWMB, OUTPUT);
pinMode(pinBIN1, OUTPUT);
pinMode(pinBIN2, OUTPUT);

pinMode(pinSTBY, OUTPUT);

myservo1.attach(a);  // attaches the servo on pin 9 to the servo object
myservo2.attach(b);  // attaches the servo on pin 9 to the servo object
myservo3.attach(c);  // attaches the servo on pin 9 to the servo object
myservo4.attach(d);  // attaches the servo on pin 9 to the servo object

pinMode(PIN_TRIG1, OUTPUT);
pinMode(PIN_ECHO1, INPUT);

pinMode(PIN_TRIG2, OUTPUT);
pinMode(PIN_ECHO2, INPUT);

pinMode(PIN_TRIG3, OUTPUT);
pinMode(PIN_ECHO3, INPUT);
}

void loop() {
               // Motor-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 //Drive both motors CW, full speed
  motorDrive(motor1, turnCW, 255);
  motorDrive(motor2, turnCW, 255);
 
  //Keep driving for 2 secs
  delay(2000);

  //Turn towards motor1: Stop Motor1, slow Motor2
  motorStop(motor1);
  motorDrive(motor2, turnCW, 192);
 
  //Keep turning for 2 secs
  delay(2000);

  //Turn in opposite direction: Stop Motor2, slow Motor1
  motorDrive(motor1, turnCW, 192);
  delay(250);
  motorStop(motor2);

  //Keep turning for 2 secs
  delay(2000);

  //Straighten up
  motorDrive(motor2, turnCW, 192);
  delay(500);
 
  //Put motors into Standby
  motorsStandby();
  delay(1000);
 
  //Do a tight turn towards motor1: Motor2 forward, Motor1 reverse
  motorDrive(motor1, turnCCW, 192);
  motorDrive(motor2, turnCW, 192);
 
  //Keep turning for 2 secs
  delay(2000);
 

  //Apply Brakes, then into Standby
  motorBrake(motor1);
  motorBrake(motor2);
  motorsStandby();

  //Stand still for 5 secs, then we do it all over again...
  delay(5000);

             // Servo---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  myservo1.write(val1);                  // sets the servo position according to the scaled value
  delay(15);
  myservo2.write(val2);                  // sets the servo position according to the scaled value
  delay(15);
  myservo3.write(val3);                  // sets the servo position according to the scaled value
  delay(15);
  myservo4.write(val4);                  // sets the servo position according to the scaled value
  delay(15);
             // HC-SR04-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  digitalWrite(PIN_TRIG1, LOW);
  delayMicroseconds(5);
  digitalWrite(PIN_TRIG1, HIGH);

  // Выставив высокий уровень сигнала, ждем около 10 микросекунд. В этот момент датчик будет посылать сигналы с частотой 40 КГц.
  delayMicroseconds(10);
  digitalWrite(PIN_TRIG1, LOW);

  //  Время задержки акустического сигнала на эхолокаторе.
  duration1 = pulseIn(PIN_ECHO1, HIGH);

  // Теперь осталось преобразовать время в расстояние
  cm1 = (duration2 / 2) / 29.1;

  Serial.print("Расстояние до объекта: ");
  Serial.print(cm1);
  Serial.println(" см.");

  // Задержка между измерениями для корректной работы скеча
  delay(250);
  //--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  digitalWrite(PIN_TRIG2, LOW);
  delayMicroseconds(5);
  digitalWrite(PIN_TRIG2, HIGH);

  // Выставив высокий уровень сигнала, ждем около 10 микросекунд. В этот момент датчик будет посылать сигналы с частотой 40 КГц.
  delayMicroseconds(10);
  digitalWrite(PIN_TRIG2, LOW);

  //  Время задержки акустического сигнала на эхолокаторе.
  duration2 = pulseIn(PIN_ECHO2, HIGH);

  // Теперь осталось преобразовать время в расстояние
  cm2 = (duration2 / 2) / 29.1;

  Serial.print("Расстояние до объекта: ");
  Serial.print(cm2);
  Serial.println(" см.");

  // Задержка между измерениями для корректной работы скеча
  delay(250);
  //--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  digitalWrite(PIN_TRIG3, LOW);
  delayMicroseconds(5);
  digitalWrite(PIN_TRIG3, HIGH);

  // Выставив высокий уровень сигнала, ждем около 10 микросекунд. В этот момент датчик будет посылать сигналы с частотой 40 КГц.
  delayMicroseconds(10);
  digitalWrite(PIN_TRIG3, LOW);

  //  Время задержки акустического сигнала на эхолокаторе.
  duration3 = pulseIn(PIN_ECHO3, HIGH);

  // Теперь осталось преобразовать время в расстояние
  cm3 = (duration3 / 2) / 29.1;

  Serial.print("Расстояние до объекта: ");
  Serial.print(cm3);
  Serial.println(" см.");

  // Задержка между измерениями для корректной работы скеча
  delay(250);
  //--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
}

void motorDrive(boolean motorNumber, boolean motorDirection, int motorSpeed)
{
  /*
  This Drives a specified motor, in a specific direction, at a specified speed:
    - motorNumber: motor1 or motor2 ---> Motor 1 or Motor 2
    - motorDirection: turnCW or turnCCW ---> clockwise or counter-clockwise
    - motorSpeed: 0 to 255 ---> 0 = stop / 255 = fast
  */

  boolean pinIn1;  //Relates to AIN1 or BIN1 (depending on the motor number specified)

 
//Specify the Direction to turn the motor
  //Clockwise: AIN1/BIN1 = HIGH and AIN2/BIN2 = LOW
  //Counter-Clockwise: AIN1/BIN1 = LOW and AIN2/BIN2 = HIGH
  if (motorDirection == turnCW)
    pinIn1 = HIGH;
  else
    pinIn1 = LOW;

//Select the motor to turn, and set the direction and the speed
  if(motorNumber == motor1)
  {
    digitalWrite(pinAIN1, pinIn1);
    digitalWrite(pinAIN2, !pinIn1);  //This is the opposite of the AIN1
    analogWrite(pinPWMA, motorSpeed);
  }
  else
  {
    digitalWrite(pinBIN1, pinIn1);
    digitalWrite(pinBIN2, !pinIn1);  //This is the opposite of the BIN1
    analogWrite(pinPWMB, motorSpeed);
  }
   
 

//Finally , make sure STBY is disabled - pull it HIGH
  digitalWrite(pinSTBY, HIGH);

}

void motorBrake(boolean motorNumber)
{
/*
This "Short Brake"s the specified motor, by setting speed to zero
*/

  if (motorNumber == motor1)
    analogWrite(pinPWMA, 0);
  else
    analogWrite(pinPWMB, 0);
   
}


void motorStop(boolean motorNumber)
{
  /*
  This stops the specified motor by setting both IN pins to LOW
  */
  if (motorNumber == motor1) {
    digitalWrite(pinAIN1, LOW);
    digitalWrite(pinAIN2, LOW);
  }
  else
  {
    digitalWrite(pinBIN1, LOW);
    digitalWrite(pinBIN2, LOW);
  } 
}


void motorsStandby()
{
  /*
  This puts the motors into Standby Mode
  */
  digitalWrite(pinSTBY, LOW);
}